class Program : System.Windows.Forms.Form
{
	Program()
	{
		TUGames.PF.Init( this );
		TUGames.GL.Init( Handle );
		TUGames.GL.LookAt( 0, 0, 0,  1, 1, -1,  0, 0, 1 );
	}

	protected override void OnPaint( System.Windows.Forms.PaintEventArgs e )
	{
		var	va = new float[]{
			-0.5f, -0.5f, -0.5f,
			-0.5f,  0.5f, -0.5f,
			-0.5f, -0.5f,  0.5f,
			-0.5f,  0.5f,  0.5f,

			-0.5f, -0.5f, -0.5f,
			 0.5f, -0.5f, -0.5f,
			-0.5f, -0.5f,  0.5f,
			 0.5f, -0.5f,  0.5f,

			-0.5f, -0.5f,  0.5f,
			 0.5f, -0.5f,  0.5f,
			-0.5f,  0.5f,  0.5f,
			 0.5f,  0.5f,  0.5f,
		};

		var na = new float[]{
			-1,  0,  0,
			-1,  0,  0,
			-1,  0,  0,
			-1,  0,  0,

			 0, -1,  0,
			 0, -1,  0,
			 0, -1,  0,
			 0, -1,  0,

			 0,  0,  1,
			 0,  0,  1,
			 0,  0,  1,
			 0,  0,  1,
		};

		TUGames.GL.EnableClientState( TUGames.GL.VERTEX_ARRAY );
		TUGames.GL.VertexPointer( 3, TUGames.GL.FLOAT, 0, va );

		TUGames.GL.EnableClientState( TUGames.GL.NORMAL_ARRAY );
		TUGames.GL.NormalPointer( TUGames.GL.FLOAT, 0, na );

		TUGames.GL.Enable( TUGames.GL.LIGHTING );
		TUGames.GL.Enable( TUGames.GL.LIGHT0 );
		TUGames.GL.Lightfv( TUGames.GL.LIGHT0, TUGames.GL.POSITION, new float[]{ -1, -2,  4,  0 } );
		TUGames.GL.Lightfv( TUGames.GL.LIGHT0, TUGames.GL.DIFFUSE , new float[]{  2,  0,  0,  1 } );

		TUGames.GL.DrawElements( TUGames.GL.TRIANGLES, 3 * 2 * 3, TUGames.GL.UNSIGNED_BYTE, new byte[]{
		 0, 1, 2,  2, 1, 3,
		 4, 5, 6,  6, 5, 7,
		 8, 9,10, 10, 9,11,
		} );

		TUGames.GL.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
