class Program : System.Windows.Forms.Form
{
	double	mAngle = 0.8;
	float[]	mVA;
	float[]	mNA;
//	uint[]	mCA;
	byte[]	mIA;

	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		TUGames.PF.Init( this );
		TUGames.GL.Init( Handle );
		TUGames.GL.Enable( TUGames.GL.DEPTH_TEST );

		mVA = new float[]{
			-0.5f, -0.5f, -0.5f,
			-0.5f,  0.5f, -0.5f,
			-0.5f, -0.5f,  0.5f,
			-0.5f,  0.5f,  0.5f,

			-0.5f, -0.5f, -0.5f,
			 0.5f, -0.5f, -0.5f,
			-0.5f, -0.5f,  0.5f,
			 0.5f, -0.5f,  0.5f,

			 0.5f,  0.5f, -0.5f,
			 0.5f, -0.5f, -0.5f,
			 0.5f,  0.5f,  0.5f,
			 0.5f, -0.5f,  0.5f,

			 0.5f,  0.5f, -0.5f,
			-0.5f,  0.5f, -0.5f,
			 0.5f,  0.5f,  0.5f,
			-0.5f,  0.5f,  0.5f,

			-0.5f, -0.5f,  0.5f,
			 0.5f, -0.5f,  0.5f,
			-0.5f,  0.5f,  0.5f,
			 0.5f,  0.5f,  0.5f,
		};

		mNA = new float[]{
			-1,  0,  0,
			-1,  0,  0,
			-1,  0,  0,
			-1,  0,  0,

			 0, -1,  0,
			 0, -1,  0,
			 0, -1,  0,
			 0, -1,  0,

			 1,  0,  0,
			 1,  0,  0,
			 1,  0,  0,
			 1,  0,  0,

			 0,  1,  0,
			 0,  1,  0,
			 0,  1,  0,
			 0,  1,  0,

			 0,  0,  1,
			 0,  0,  1,
			 0,  0,  1,
			 0,  0,  1,
		};

/*
		mCA = new uint[]{
			0xff0000ff,
			0xff0000ff,
			0xff0000ff,
			0xff0000ff,

			0xff00ff00,
			0xff00ff00,
			0xff00ff00,
			0xff00ff00,

			0xffffffff,
			0xffffff00,
			0xffff00ff,
			0xff00ffff,

			0xffffffff,
			0xffffff00,
			0xffff00ff,
			0xff00ffff,

			0xffffffff,
			0xffffff00,
			0xffff00ff,
			0xff00ffff,
		};
*/

		mIA = new byte[]{
			 0, 1, 2,  2, 1, 3,
			 4, 5, 6,  6, 5, 7,
			 8, 9,10, 10, 9,11,
			12,13,14, 14,13,15,
			16,17,18, 18,17,19,
		};

	}

	protected override void OnPaint( System.Windows.Forms.PaintEventArgs e )
	{
		TUGames.GL.Clear( TUGames.GL.COLOR_BUFFER_BIT | TUGames.GL.DEPTH_BUFFER_BIT );
		TUGames.GL.LoadIdentity();
		TUGames.GL.Ortho( -1, 1, -1, 1,  0, 3 );
		TUGames.GL.LookAt( (float)System.Math.Cos(mAngle), (float)System.Math.Sin(mAngle), 1,  0, 0, 0, 0, 0, 1 );
		mAngle += 0.001;

		TUGames.GL.Enable( TUGames.GL.LIGHTING );
		TUGames.GL.Enable( TUGames.GL.LIGHT0 );
		TUGames.GL.Lightfv( TUGames.GL.LIGHT0, TUGames.GL.POSITION, new float[]{ -1, -2,  4,  0 } );
		TUGames.GL.Lightfv( TUGames.GL.LIGHT0, TUGames.GL.DIFFUSE , new float[]{  0.5f,  0.5f,  1,  1 } );
		TUGames.GL.Lightfv( TUGames.GL.LIGHT0, TUGames.GL.AMBIENT , new float[]{  0.1f,  0.1f,  0.2f,  1 } );

		TUGames.GL.EnableClientState( TUGames.GL.VERTEX_ARRAY );
		TUGames.GL.VertexPointer( 3, TUGames.GL.FLOAT, 0, mVA );

		TUGames.GL.EnableClientState( TUGames.GL.NORMAL_ARRAY );
		TUGames.GL.NormalPointer( TUGames.GL.FLOAT, 0, mNA );

//		TUGames.GL.EnableClientState( TUGames.GL.COLOR_ARRAY );
//		TUGames.GL.ColorPointer( 4, TUGames.GL.UNSIGNED_BYTE, 0, mCA );

		TUGames.GL.DrawElements( TUGames.GL.TRIANGLES, 5 * 2 * 3, TUGames.GL.UNSIGNED_BYTE, mIA );

		TUGames.GL.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示

		Invalidate();
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
