class Program : System.Windows.Forms.Form
{
	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		ClientSize = new System.Drawing.Size( 480, 480 );
		TUGames.GU.Init( this );	//	自身を指定してライブラリ初期化
		TUGames.GU.SwapIntervalEXT( 1 );	//	垂直同期を待つ（重い）
		TUGames.GU.ClearColor( 0xffff0000 );	//	背景色をABGR形式で設定
		TUGames.GU.Enable( TUGames.GU.BLEND );	//	ブレンド機能を有効化
		TUGames.GU.BlendFunc( TUGames.GU.SRC_ALPHA, TUGames.GU.ONE_MINUS_SRC_ALPHA );

		var		bm = TUGames.PF.GetBitmap(
		 "Hello World",
		 new System.Drawing.Font( "MS Gothic", 32, System.Drawing.FontStyle.Bold ),
		 System.Drawing.Color.Yellow
		);

		uint	tex = TUGames.GU.CreateTexture();
		TUGames.GU.BindTexture( tex );
		TUGames.GU.TexParameterFilter( TUGames.GU.NEAREST );
		TUGames.GU.TexImage2D( bm );

		float	x = -1.0f;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( ( x += 1.0f / 480 ) >= 1.0f ){
				x = -1.0f;
			}
		},
		() =>{	//	描画処理
			TUGames.GU.Clear( TUGames.GU.COLOR_BUFFER_BIT );	//	設定された背景色で画面初期化
			TUGames.GU.DrawTexture( tex, x, 0.5f, 0.0f, bm.Width / 240.0f, -bm.Height / 240.0f );	//	指定したテクスチャ、座標 XYZ と幅高さ Width, Height で、矩形を描画
			TUGames.GU.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
