class Program : System.Windows.Forms.Form
{
	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		ClientSize = new System.Drawing.Size( 480, 480 );
		TUGames.GU.Init( this );	//	自身を指定してライブラリ初期化
		TUGames.GU.ClearColor( 0xff00aa00 );	//	背景色をABGR形式で設定
		TUGames.GU.SwapIntervalEXT( 1 );	//	垂直同期を待つ（重い）
		TUGames.GU.Enable( TUGames.GU.BLEND );	//	ブレンド機能を有効化
		TUGames.GU.Enable( TUGames.GU.ALPHA_TEST );
		TUGames.GU.BlendFunc( TUGames.GU.SRC_ALPHA, TUGames.GU.ONE_MINUS_SRC_ALPHA );

		var	t = TUGames.GU.CreateTexImage( 4, 4, new ushort[]{
		 0xffff, 0x00ff, 0x00ff, 0x0000,
		 0xffff, 0xfaaf, 0xfaaf, 0x0000,
		 0xfaaf, 0x00ff, 0x00ff, 0xfaaf,
		 0x0000, 0x00ff, 0x00ff, 0x0000,
		} );

		int		x = 0, y = 0;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) )	x--;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) )	x++;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ) )	y++;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) )	y--;	//	引数で指定されたキーが押されている場合
		},
		() =>{	//	描画処理
			TUGames.GU.Clear( TUGames.GU.COLOR_BUFFER_BIT | TUGames.GU.DEPTH_BUFFER_BIT );	//	設定された背景色で画面初期化
			TUGames.GU.DrawTexture( t, x / 240.0f, y / 240.0f, 0, 64 / 240.0f, -64 / 240.0f );
			TUGames.GU.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
