class Program : System.Windows.Forms.Form
{
	double	mAngle = 0.8;

	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		ClientSize = new System.Drawing.Size( 480, 480 );
		TUGames.GU.Init( this );	//	自身とウィンドウサイズを指定してライブラリ初期化
		TUGames.GU.Enable( TUGames.GL.DEPTH_TEST );
	}

	protected override void OnPaint( System.Windows.Forms.PaintEventArgs e )
	{
		TUGames.GU.Clear( TUGames.GL.COLOR_BUFFER_BIT | TUGames.GL.DEPTH_BUFFER_BIT );
		TUGames.GU.U_LoadIdentity();
		TUGames.GU.U_Ortho( -1, 1, -1, 1,  0, 3 );
		TUGames.GU.U_LookAt( (float)System.Math.Cos(mAngle), (float)System.Math.Sin(mAngle), 1,  0, 0, 0, 0, 0, 1 );
		mAngle += 0.001;

		TUGames.GU.FillRectZN( -0.5f, -0.5f,  0.5f,  1.0f, 1.0f, 0xffffffff );	//	指定した座標 XYZ と X長さ、Y長さ、色 ABGR で、Z面に矩形を描画
		TUGames.GU.FillRectXN( -0.5f,  0.5f, -0.5f, -1.0f, 1.0f, 0xffffffff );	//	指定した座標 XYZ と Y長さ、Z長さ、色 ABGR で、X面に矩形を描画
		TUGames.GU.FillRectYN( -0.5f, -0.5f, -0.5f,  1.0f, 1.0f, 0xffffffff );	//	指定した座標 XYZ と X長さ、Z長さ、色 ABGR で、Y面に矩形を描画
		TUGames.GU.FillRectXN(  0.5f, -0.5f, -0.5f,  1.0f, 1.0f, 0xffffffff );	//	指定した座標 XYZ と Y長さ、Z長さ、色 ABGR で、X面に矩形を描画
		TUGames.GU.FillRectYN(  0.5f,  0.5f, -0.5f, -1.0f, 1.0f, 0xffffffff );	//	指定した座標 XYZ と X長さ、Z長さ、色 ABGR で、Y面に矩形を描画

		TUGames.GU.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示

		Invalidate();
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
