class Program : System.Windows.Forms.Form
{
	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		TUGames.GX.Init( this, 640, 480 );	//	自身、ウィンドウサイズ横、縦を指定してライブラリ初期化
		TUGames.GX.ClearColor( 0xffffff00 );	//	背景色をABGR形式で設定
		TUGames.GX.FontSize = 32;	//	文字列描画時の大きさを設定

		int		x = 320, y = 240;

		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) )	x--;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ) )	y--;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) )	x++;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) )	y++;	//	引数で指定されたキーが押されている場合
		},
		() =>{	//	描画処理
			TUGames.GX.Clear();	//	設定された背景色で画面初期化
			TUGames.GX.FillRectZ( 8, 8, 0, 624, 464, 0xffff0000 );
			TUGames.GX.DrawString( "Left" , 50,  50, 1, 0xff00ffff );	//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( "Up"   , 50, 100, 1, 0xffff00ff );	//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( "Right", 50, 150, 1, 0xffffff00 );	//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( "Down" , 50, 200, 1, 0xff00ff00 );	//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( ": " + TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ),  200,  50, 1, 0xffaaffff );//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( ": " + TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ),  200, 100, 1, 0xffffaaff );//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( ": " + TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ),  200, 150, 1, 0xffffffaa );//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.DrawString( ": " + TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ),  200, 200, 1, 0xffaaffaa );//	座標XYZへ、ABGR形式で指定した色で文字列を描画
			TUGames.GX.FillRectZ( x, y, 2, 40, 40, 0xaa00ffff );	//	座標XYZへ、幅高さWH、ABGR形式で指定した色で矩形を描画
			TUGames.GX.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
