class Program : System.Windows.Forms.Form
{
	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		TUGames.GX.Init( this, 640, 480 );	//	自身、ウィンドウサイズ横、縦を指定してライブラリ初期化
		TUGames.GX.ClearColor( 0xff00aa00 );	//	背景色をABGR形式で設定
		TUGames.GX.RGBA4444 = true;

		uint	t = TUGames.GX.LoadTexture( "../assets/player.png" );	//	指定されたファイルをテクスチャ画像として読み込む
/*
		uint	t = TUGames.GX.LoadTexture(
		 TUGames.PF.GetBitmap( TUGames.TUPicture.CreateFromBin( new byte[]{
			0x54,0x55,0x50,0x20,0x31,0x5a,0x10,0x00,0x20,0x00,0x03,0xaf,0x5a,0xf5,0xff,0x0f,
			0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x0d,0xf0,0x51,0xc5,0x89,0xe2,0xad,0xd6,
			0x41,0x41,0x06,0x41,0x0c,0x41,0x5f,0xd7,0x0d,0xf0,0x51,0xc5,0x89,0xe2,0xad,0xd6,
			0x46,0x41,0x0c,0x41,0x0f,0x41,0xcf,0xd4,0x1f,0x70,0x5d,0x01,0x87,0xd6,0xad,0xc0,
			0x44,0xf1,0x24,0xc0,0x04,0xd0,0x4d,0xc3,0x1f,0x70,0x5d,0x01,0x87,0xd6,0xad,0xc0,
			0x44,0xf1,0x24,0xc0,0x44,0x40,0xfd,0x0f,0x0d,0xf4,0x40,0x75,0x97,0xd2,0x03,0x76,
			0x4f,0x1d,0x83,0x10,0x07,0x10,0xc3,0x71,0x0d,0xf4,0x40,0x75,0x97,0xd2,0x03,0x76,
			0x4f,0x1d,0x03,0x12,0x01,0x11,0xf0,0x7f,0x4f,0x71,0x05,0x40,0x01,0x50,0x51,0x75,
			0x81,0x92,0x05,0xf0,0x03,0xc0,0xc3,0xc3,0x4f,0x71,0x05,0x40,0x01,0x50,0x51,0x75,
			0x81,0xb2,0x05,0xd0,0x0f,0xf0,0x0f,0xff,
		} ) ) );
*/

		int		x = 320, y = 240;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) )	x--;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) )	x++;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ) )	y--;	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) )	y++;	//	引数で指定されたキーが押されている場合
		},
		() =>{	//	描画処理
			TUGames.GX.Clear();	//	設定された背景色で画面初期化
			TUGames.GX.DrawTexture( t, x, y, 0, 64, 128 );	//	指定されたテクスチャを、座標XYZへ幅高さWHにして描画
			TUGames.GX.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
