class Program : System.Windows.Forms.Form
{
	public static byte[,]	Map = {
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
		{ 0, 0, 3, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
		{ 0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 3, 0, 3, 0, 0, },
		{ 0, 3, 3, 7, 7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 3, 6, 3, 6, 3, 0, },
		{ 0, 3, 3, 6, 6, 7, 7, 7, 2, 2, 2, 7, 7, 7, 7, 7, 7, 7, 6, 3, },
		{ 0, 0, 3, 3, 6, 6, 6, 7, 7, 2, 2, 2, 7, 7, 2, 2, 2, 7, 7, 6, },
		{ 0, 3, 3,10,11, 3, 3, 6, 7, 7, 2, 2, 2, 2, 2, 2, 1, 1, 7, 6, },
		{ 0, 0, 3, 3, 3, 0, 3, 3, 3, 7, 7, 2, 2, 2, 2, 7, 7, 1, 1, 6, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 7, 7, 7, 7, 2, 7, 6, 3, 1, 3, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 6, 6, 7, 2, 7, 6, 3, 1, 3, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 6, 7, 7, 7, 6, 3, 1, 1, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 6, 6, 7, 7, 7, 6, 3, 1, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 6, 6, 6, 7, 7, 6, 3, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 3, 3, 6, 6, 6, 6, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 3, 3, 3, 3, 6, 6, },
	};

	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		TUGames.GX.Init( this, 640, 480 );	//	自身、ウィンドウサイズ横、縦を指定してライブラリ初期化

		uint[]	field = TUGames.GX.LoadTextureDiv( "../assets/field.png", 8, 8 );	//	指定されたファイルをテクスチャ画像として分割して読み込む
		uint[]	player = TUGames.GX.LoadTextureDiv( "../assets/player.png", 8, 8 );	//	指定されたファイルをテクスチャ画像として分割して読み込む

//		int		px = 320, py = 240, an = 0;
		int[]	px = { 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320, 320 };
		int[]	py = { 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240 };
		int[]	an = {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 };
		int		pi = 0;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			int		ni = ( pi + 1 ) & 31;
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) ){	px[ ni ] = px[ pi ] - 4;	py[ ni ] = py[ pi ];	an[ ni ] = 2;	pi = ni;	}else	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ) ){	py[ ni ] = py[ pi ] - 4;	px[ ni ] = px[ pi ];	an[ ni ] = 6;	pi = ni;	}else	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) ){	px[ ni ] = px[ pi ] + 4;	py[ ni ] = py[ pi ];	an[ ni ] = 4;	pi = ni;	}else	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) ){	py[ ni ] = py[ pi ] + 4;	px[ ni ] = px[ pi ];	an[ ni ] = 0;	pi = ni;	}		//	引数で指定されたキーが押されている場合
		},
		() =>{	//	描画処理
			TUGames.GX.Clear();	//	設定された背景色で画面初期化

			//	マップ描画
			for( int y = 0; y < 15; y++ ){
				for( int x = 0; x < 20; x++ ){
					TUGames.GX.DrawTexture( field[ Map[ y, x ] ], x * 32, y * 32, 0, 32, 32 );	//	指定されたテクスチャを、座標XYZへ幅高さWHにして描画
				}
			}

			//	プレイヤー
			for( int i = 0; i < 32; i += 8 ){
				int		j = ( pi + i ) & 31;
				TUGames.GX.DrawTexture( player[ an[ j ] | ( ( px[ j ] + py[ j ] ) >> 4 & 1 ) ], px[ j ], py[ j ], 1, 32, 32 );	//	指定されたテクスチャを、座標XYZへ幅高さWHにして描画
			}

			TUGames.GX.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
