using System;
using System.Collections.Generic;



class Car : TUGames.Sprite
{
	public float	mSpeed;
	public float 	mDX;

	public Car( TUGames.TexTile textile, int cidx ) : base( 32, 64, textile, cidx, 1, 2 )
	{
	}
}


class Enemy : Car
{
	public Enemy( TUGames.TexTile textile, int spd ) : base( textile, 25 )
	{
		X = TUGames.UT.Rnd( 200 ) + 140 - 16;
		Y = -64;
		mDX = ( TUGames.UT.Rnd( 13 ) - 6 ) / 4.0f;
		mSpeed = TUGames.UT.Rnd( spd ) + 10000;
	}
}


class Player : Car
{
	public bool	mBrake;

	public Player( TUGames.TexTile textile ) : base( textile, 24 )
	{
		mSpeed = 6000;
		X = Program.WIDTH / 2 - 16;
		Y = Program.HEIGHT - 80;
	}


	public void tick()
	{
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) ){	//	引数で指定されたキーが押されている場合
			if( mDX == 0 ){
				X -= 2;
				mSpeed -= 50;
			}else if( mDX < 0 && mDX > -2 ){
				mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) ){	//	引数で指定されたキーが押されている場合
			if( mDX == 0 ){
				X += 2;
				mSpeed -= 50;
			}else if( mDX > 0 && mDX < 2 ){
				mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Z     ) ||
		    TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) ){	//	引数で指定されたキーが押されている場合
			mSpeed = System.Math.Max( 6000, mSpeed - 500 );
			mBrake = true;
		}

		mSpeed += Math.Min( 50, 1000000 / mSpeed );
		X += mDX;
		mDX -= Math.Sign( mDX ) * Math.Min( Math.Abs( mDX ), 0.02f );
	}
}


class Program : System.Windows.Forms.Form
{
	static byte[][,]	Map = {
		new byte[,]{
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
			{ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, },
		},
		new byte[,]{
			{ 9, 9,10,10,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, },
			{ 9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, },
			{ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, },
			{ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, },
			{ 9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, },
			{ 9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, },
			{ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, },
			{ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, },
			{ 9, 9,10,11,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, },
			{ 9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, },
			{ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, },
			{ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, },
			{ 9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, },
			{ 9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, },
			{ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, },
			{ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, },
		},
	};

	public const int WIDTH  = 480;
	public const int HEIGHT = 360;
	public const int LENGTH = 64000;

	public static Random	mRnd = new Random();


	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止

		TUGames.GX.Init( this, WIDTH, HEIGHT, 1.5f, 8 );	//	自身、ウィンドウサイズ幅高さを指定してライブラリ初期化

		var	tex = TUGames.Texture.Create( 0x80, 0x80 );
		tex.texSubImage2D( 0x00, 0x00, TUGames.TURawImage.CreateFromBitmap( new System.Drawing.Bitmap( "../assets/8x8_4c_2bpp.png" ), 16 ) );
		tex.texSubImage2D( 0x00, 0x40, TUGames.TURawImage.CreateFromBitmap( new System.Drawing.Bitmap( "../assets/font_8x12.png" ), 16 ).clone( 0, 24, 128, 48 ) );

		var	ttc = new TUGames.TexTile( tex, 8, 0.5f / 8, 0.5f / 8 );
		var	field = new TUGames.BG( new TUGames.PriTile( 16, 16, 32, 32, 2, ttc ) );
		field.setIndex( Map );

		var	tf = new TUGames.TexFont( new TUGames.TexTile( tex, 16, 8 / 128.0f, 12 / 128.0f, 0.0f, 0.5f ) );
		tf.initHCode( 0x40, 0x20 );
		var	pt = new TUGames.PriStr[ 4 ];
		pt[ 0 ] = TUGames.PriStr.Create( "TIME"  , tf,  4,  28 * 1 + 6, 0xffffffff, 0xaaffffff, 0xff000000 );
		pt[ 1 ] = TUGames.PriStr.Create( ""      , tf, 12,  28 * 2 + 6, 0xffffffff, 0xaaffffff, 0xff000000 );
		pt[ 2 ] = TUGames.PriStr.Create( "SPEED" , tf,  4,  28 * 4 + 6, 0xffffffff, 0xaaffffff, 0xff000000 );
		pt[ 3 ] = TUGames.PriStr.Create( ""      , tf, 12,  28 * 5 + 6, 0xffffffff, 0xaaffffff, 0xff000000 );

		var	player = new Player( ttc );
		var	enemy = new List<Enemy>();

		float	py = 0;
		int		ani = -1;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( py - LENGTH > -0x200 && Map[ 1 ][ 0, 4 ] == 16 ){	//	ゴール目前に迫った場合
				Map[ 1 ][ 0,  4 ] = 13;
				Map[ 1 ][ 0,  5 ] = 13;
				Map[ 1 ][ 0,  6 ] = 13;
				Map[ 1 ][ 0,  7 ] = 14;
				Map[ 1 ][ 0,  8 ] = 15;
				Map[ 1 ][ 0,  9 ] = 13;
				Map[ 1 ][ 0, 10 ] = 13;
				Map[ 1 ][ 0, 11 ] = 13;
				field.setIndex( Map );
			}
			if( py - LENGTH > -0x200 + 276 ){	//	ゴールした場合
				player.mSpeed = 0;
				return;
			}

			var		tm = (int)( TUGames.PF.LoopCount * 100 / 60 );
			var		st = (int)( tm / 100 ) + "." + ( tm / 10 % 10 ) + ( tm % 10 );
			pt[ 1 ].setString( st.PadLeft( 6, ' ' ) );

			if( ani == 0 ){	//	衝突した場合
				player.mSpeed = 0;
				player.setCClm( 2 );
				player.setWH( 64, 64 );
				player.setCIdx( 40 );
				player.X -= 16;
				ani = 1;
			}

			if( ani > 0 ){	//	爆発アニメ中の場合
				++ani;
				if( ( ani & 7 ) == 0 ){
					int	i = ani >> 2;
					if( i < 8 ){
						player.setCIdx( 40 + i );
					}
				}
				if( ani == 100 ){
					ani = -1;
					player.X = WIDTH / 2 - 16;
					player.setCClm( 1 );
					player.setWH( 32, 64 );
					player.setCIdx( 24 );
					player.mDX = 0;
					player.mSpeed = 1000;
				}
			}

			if( ( player.X < WIDTH / 2 - 16 - 112 || player.X > WIDTH / 2 - 16 + 112 ) && player.mSpeed >= 6000 && ani < 0 ){	//	壁に激突した場合
				ani = 0;
			}

			player.tick();
			if( ani >= 0 ){
				player.mSpeed = 0;
			}

			int		ps = (int)( player.mSpeed / 2.0f );
			string	s = ( ps / 100 ) + "." + ( ps / 10 % 10 ) + ( ps % 10 );
			pt[ 3 ].setString( s.PadLeft( 6, ' ' ) );

			if( ani < 0 ){
				py += player.mSpeed / 4096;
			}

			int	ds = (int)player.mSpeed - 10000;
			if( ds > 1000 && mRnd.Next( 30 + enemy.Count * 40 ) == 0 ){
				enemy.Add( new Enemy( ttc, ds ) );
			}

			for( int i = enemy.Count - 1; i >= 0; i-- ){
				var	e = enemy[ i ];
				if( ani < 0 && player.isCollision( e ) ){
					float	dx = e.X - player.X;
					float	dy = e.Y - player.Y;
					float	ss = player.mSpeed;
					player.mSpeed = e.mSpeed;
					e.mSpeed = ss;
					player.mDX = -dx / 16;
					e.mDX = dx / 16;
				}
				e.X += e.mDX;
				e.Y += ( player.mSpeed - e.mSpeed ) / 4096;
				if( e.X > WIDTH / 2 + 112 - 16 && e.mDX > 0 ){
					e.mDX = -e.mDX;
				}
				if( e.X < WIDTH / 2 - 112 - 16 && e.mDX < 0 ){
					e.mDX = -e.mDX;
				}
				if( e.Y > 360 ){
					enemy.RemoveAt( i );
				}
			}
		},
		() =>{	//	描画処理
			TUGames.GX.Clear();	//	設定された背景色で画面初期化

			field.drawFull( -16, py - LENGTH, WIDTH, HEIGHT );
			player.draw();
			for( int i = 0; i < enemy.Count; i++ ){
				enemy[ i ].draw();
			}
			for( int i = 0; i < pt.Length; i++ ){
				pt[ i ].draw();
			}

			TUGames.GX.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}

}
