using System;
using System.Collections.Generic;



class Car : TUGames.ControlBase
{
	public float	mSpeed;
	public float 	mDX;

	public Car() : base( 0, 0, 64, 128 )
	{
	}
}


class Enemy : Car
{
	public static Enemy[]		sObj = new Enemy[ 0x10 ];

	public int		mAlive;

	public Enemy( int spd ) : base()
	{
		init( spd );
	}

	public static int Appear( int spd )
	{
		for( int i = 0; i < sObj.Length; i++ ){
			if( sObj[ i ] == null ){
				sObj[ i ] = new Enemy( spd );
				return( i );
			}
			if( sObj[ i ].mAlive == 0 ){
				sObj[ i ].init( spd );
				return( -1 );
			}
		}
		return( -2 );
	}

	public static int CountAlive()
	{
		int		r = 0;
		for( int i = sObj.Length - 1; i >= 0; i-- ){
			if( sObj[ i ] != null ){
				r += sObj[ i ].mAlive;
			}
		}
		return( r );
	}


	void init( int spd )
	{
		X = TUGames.UT.Rnd( 400 ) + 280 - 32;
		Y = -128;
		mDX = ( TUGames.UT.Rnd( 13 ) - 6 );
		mSpeed = TUGames.UT.Rnd( spd ) + 10000;
		mAlive = 1;
	}
}


class Player : Car
{
	public bool	mBrake;
	public int	mCIdx = -1;
	public int	mCClm = -1;
	public ushort	mSetW;
	public ushort	mSetH;

	public Player() : base()
	{
		mSpeed = 6000;
		X = Program.WIDTH / 2 - 32;
		Y = Program.HEIGHT - 160;
	}


	public void setCClm( int val )
	{
		mCClm = val;
	}

	public void setCIdx( int cidx )
	{
		mCIdx = cidx;
	}

	public override void setWH( float width, float height )
	{
		mSetW = (ushort)width;
		mSetH = (ushort)height;
		base.setWH( width, height );
	}

	public void tick()
	{
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) ){	//	引数で指定されたキーが押されている場合
			if( mDX == 0 ){
				X -= 8;
				mSpeed -= 100;
			}else if( mDX < 0 && mDX > -8 ){
				mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) ){	//	引数で指定されたキーが押されている場合
			if( mDX == 0 ){
				X += 8;
				mSpeed -= 100;
			}else if( mDX > 0 && mDX < 8 ){
				mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Z     ) ||
		    TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) ){	//	引数で指定されたキーが押されている場合
			mSpeed = System.Math.Max( 6000, mSpeed - 500 );
			mBrake = true;
		}

		mSpeed += Math.Min( 100, 2000000 / mSpeed );
		X += mDX;
		mDX -= Math.Sign( mDX ) * Math.Min( Math.Abs( mDX ), 0.08f );
	}
}


class Program : TUGames.Client
{
	static byte[]	Map0 = {
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
		5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1,
	};

	static byte[]	Map1 = {
		9, 9,10,10,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8,
		9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8,
		9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8,
		9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8,
		9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8,
		9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8,
		9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8,
		9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8,
		9, 9,10,11,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8,
		9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8,
		9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8,
		9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8,
		9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8,
		9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8,
		9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8,
		9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8,
	};

	public const int	WIDTH  = 960;
	public const int	HEIGHT = 720;
	public const int	LENGTH = 128000;
	public const int	FPS    = 30;

	public static Random	mRnd = new Random();

	int		mScene;


	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止

		cmd( GX_Init( WIDTH, HEIGHT, 0.875f, 8 ) );	//	自身、ウィンドウサイズ幅高さを指定してライブラリ初期化

		cmd( TX_Create( 0x80, 0x80 ) );
		cmd( new byte[]{	MOV_AR,	0x00,	DX,	} );

		cmd( PI_CreateFromBin( System.IO.File.ReadAllBytes( "../assets/8x8_4c_2bpp.tup" ) ) );
		cmd( new byte[]{	MOV_AR,	0xfe,	DX,	} );
		cmd( new byte[]{	MOV_RA,	CX,	0xfe,	} );
		cmd( RI_CreateFromTUPictureCX() );

		cmd( new byte[]{	MOV_RA,	BX,	0x00	}	);
		cmd( new byte[]{	MOV_DI_DX	}	);
		cmd( TX_texSubImage2DBXDI( 0x00, 0x00 ) );

		cmd( PI_CreateFromBin( System.IO.File.ReadAllBytes( "../assets/font_8x12.tup" ) ) );
		cmd( new byte[]{	MOV_CX_DX	}	);
		cmd( RI_CreateFromTUPictureCX() );

		cmd( new byte[]{	MOV_BX_DX	}	);
		cmd( RI_cloneBX( 0, 24, 128, 48 ) );
		cmd( new byte[]{	MOV_RA,	BX,	0x00	}	);
		cmd( new byte[]{	MOV_DI_DX	}	);
		cmd( TX_texSubImage2DBXDI( 0x00, 0x40 ) );

		cmd ( TT_NewBX( 8, 0.5f / 8, 0.5f / 8, 0.0f, 0.0f ) );
		cmd( new byte[]{	MOV_AR,	0x02,	DX,	} );
		cmd( new byte[]{	MOV_RA,	DI,	0x02	}	);
		cmd( PT_NewDI( 16, 16, 64, 64, 2 ) );
		cmd( new byte[]{	MOV_BX_DX	}	);
		cmd( BG_NewBX() );
		cmd( new byte[]{	MOV_AR,	0x04,	DX,	} );
		cmd( new byte[]{	MOV_RA,	BX,	0x04	}	);
		cmd( BG_setXBX( -32 ) );
		cmd( BG_setWidthBX( WIDTH ) );
		cmd( BG_setHeightBX( HEIGHT ) );

		cmd( AB_Create( Map0 ) );
		cmd( new byte[]{	MOV_RA,	BX,	0x04	}	);
		cmd( new byte[]{	MOV_CX_DX	}	);
		cmd( BG_setIndexBXCX( 0, 0, 0 ) );

		cmd( AB_Create( Map1 ) );
		cmd( new byte[]{	MOV_AR,	0x06,	DX,	} );
		cmd( new byte[]{	MOV_RA,	BX,	0x04	}	);
		cmd( new byte[]{	MOV_RA,	CX,	0x06	}	);
		cmd( BG_setIndexBXCX( 0, 0, 1 ) );

		cmd( new byte[]{	MOV_RA,	BX,	0x00	}	);
		cmd( TT_NewBX( 16, 8 / 128.0f, 12 / 128.0f, 0.0f, 0.5f ) );
		cmd( new byte[]{	MOV_BX_DX	}	);
		cmd( TF_NewBX() );
		cmd( new byte[]{	MOV_AR,	0x08,	DX,	} );
		cmd( new byte[]{	MOV_RA,	BX,	0x08	}	);
		cmd( TF_initHCodeBX( 0x40, 0x20 ) );

		cmd( PS_CreateBX( "TIME"  ,  4,  56 * 1 + 12, 0xffff, 0xafff, 0xf000 ) );
		cmd( new byte[]{	MOV_AR,	0x0a,	DX,	} );

		cmd( PS_CreateBX( ""      , 12,  56 * 2 + 12, 0xffff, 0xafff, 0xf000 ) );
		cmd( new byte[]{	MOV_AR,	0x0c,	DX,	} );

		cmd( PS_CreateBX( "SPEED" ,  4,  56 * 4 + 12, 0xffff, 0xafff, 0xf000 ) );
		cmd( new byte[]{	MOV_AR,	0x0e,	DX,	} );

		cmd( PS_CreateBX( ""      , 12,  56 * 5 + 12, 0xffff, 0xafff, 0xf000 ) );
		cmd( new byte[]{	MOV_AR,	0x10,	DX,	} );

		cmd( new byte[]{	MOV_RA,	BX,	0x02	}	);
		cmd( SP_NewBX( 64, 128, 24, 1, 2 ) );
		cmd( new byte[]{	MOV_AR,	0x12,	DX,	} );
		var	player = new Player();

		int		py = 0;
		int		ani = -1;
		int		cnt = 0;
		TUGames.PF.StartLoop( FPS,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( mScene == 0 ){
				if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Enter ) ){
					mScene = 1;
				}
				return;
			}

			cnt++;

			if( py - LENGTH > -0x400 && Map1[ 4 ] == 16 ){	//	ゴール目前に迫った場合
				Map1[  4 ] = 13;
				cmd( new byte[]{	MOV_RA,	BX,	0x06	}	);
				cmd( AB_setBX(  4, 13 ) );
				cmd( AB_setBX(  5, 13 ) );
				cmd( AB_setBX(  6, 13 ) );
				cmd( AB_setBX(  7, 14 ) );
				cmd( AB_setBX(  8, 15 ) );
				cmd( AB_setBX(  9, 13 ) );
				cmd( AB_setBX( 10, 13 ) );
				cmd( AB_setBX( 11, 13 ) );
				cmd( new byte[]{	MOV_RA,	BX,	0x04	}	);
				cmd( new byte[]{	MOV_RA,	CX,	0x06	}	);
				cmd( BG_setIndexBXCX( 0, 0, 1 ) );
			}
			if( py - LENGTH > -0x400 + 552 ){	//	ゴールした場合
				player.mSpeed = 0;
				return;
			}

			var		tm = (int)( cnt * 100 / FPS );
			var		st = (int)( tm / 100 ) + "." + ( tm / 10 % 10 ) + ( tm % 10 );
			cmd( new byte[]{	MOV_RA,	BX,	0x0c	}	);
			cmd( PS_setStringBX( st.PadLeft( 6, ' ' ) ) );

			if( ani == 0 ){	//	衝突した場合
				player.mSpeed = 0;
				player.setCClm( 2 );
				player.setWH( 128, 128 );
				player.setCIdx( 40 );
				player.X -= 32;
				ani = 1;
			}

			if( ani > 0 ){	//	爆発アニメ中の場合
				++ani;
				if( ( ani & 3 ) == 0 ){
					int	i = ani >> 1;
					if( i < 8 ){
						player.setCIdx( 40 + i );
					}
				}
				if( ani == 50 ){
					ani = -1;
					player.X = WIDTH / 2 - 32;
					player.setCClm( 1 );
					player.setWH( 64, 128 );
					player.setCIdx( 24 );
					player.mDX = 0;
					player.mSpeed = 1000;
				}
			}

			if( ( player.X < WIDTH / 2 - 32 - 224 || player.X > WIDTH / 2 - 32 + 224 ) && player.mSpeed >= 6000 && ani < 0 ){	//	壁に激突した場合
				ani = 0;
			}

			player.tick();
			if( ani >= 0 ){
				player.mSpeed = 0;
			}

			int		ps = (int)( player.mSpeed / 2.0f );
			string	s = ( ps / 100 ) + "." + ( ps / 10 % 10 ) + ( ps % 10 );
			cmd( new byte[]{	MOV_RA,	BX,	0x10	}	);
			cmd( PS_setStringBX( s.PadLeft( 6, ' ' ) ) );

			if( ani < 0 ){
				py += (int)( player.mSpeed / 1024 );
			}

			int	ds = (int)player.mSpeed - 10000;
			if( ds > 1000 && mRnd.Next( 20 + Enemy.CountAlive() * 30 ) == 0 ){
				var		e = Enemy.Appear( ds );
				if( e >= 0 ){
					cmd( new byte[]{	MOV_RA,	BX,	0x02	}	);
					cmd( SP_NewBX( 64, 128, 25, 1, 2 ) );
					cmd( new byte[]{	MOV_AR,	(byte)( 0x20 + e << 1 ), DX	}	);
				}
			}

			for( int i = Enemy.sObj.Length - 1; i >= 0; i-- ){
				var	e = Enemy.sObj[ i ];
				if( e == null ){
					continue;
				}
				if( ani < 0 && player.isCollision( e ) ){
					float	dx = e.X - player.X;
					float	dy = e.Y - player.Y;
					float	ss = player.mSpeed;
					player.mSpeed = e.mSpeed;
					e.mSpeed = ss;
					player.mDX = -dx / 8;
					e.mDX = dx / 8;
				}
				e.X += e.mDX;
				e.Y += ( player.mSpeed - e.mSpeed ) / 1024;
				if( e.X > WIDTH / 2 + 224 - 32 && e.mDX > 0 ){
					e.mDX = -e.mDX;
				}
				if( e.X < WIDTH / 2 - 224 - 32 && e.mDX < 0 ){
					e.mDX = -e.mDX;
				}
				if( e.Y > 720 ){
					Enemy.sObj[ i ].mAlive = 0;
				}
			}
		},
		() =>{	//	描画処理
			cmd( GX_Clear() );	//	設定された背景色で画面初期化

			if( mScene == 0 ){
				cmd( GX_DrawString( "レトロなスピードGP", 240, 200, 0xeb ) );
				cmd( GX_DrawString( "PUSH ENTER KEY", 300, 400, 0xff ) );
			}else{
				cmd( new byte[]{	MOV_RA,	BX,	0x04	}	);
				cmd( BG_setYBX( ( ( py - LENGTH ) & 0x3ff ) - 0x400 ) );
				cmd( BG_drawFullBX() );

				cmd( new byte[]{	MOV_RA,	BX,	0x12	}	);
				cmd( SP_setXYBX( (short)player.X, (short)player.Y ) );
				if( player.mCClm >= 0 ){
					cmd( SP_setCClmBX( (ushort)player.mCClm ) );
					player.mCClm = -1;
				}
				if( player.mCIdx >= 0 ){
					cmd( SP_setCIdxBX( (ushort)player.mCIdx ) );
					player.mCIdx = -1;
				}
				if( player.mSetW != 0 ){
					cmd( SP_setWHBX( (ushort)player.mSetW, (ushort)player.mSetH ) );
					player.mSetW = 0;
					player.mSetH = 0;
				}
				cmd( SP_drawBX() );

				for( int i = 0; i < Enemy.sObj.Length; i++ ){
					var		e = Enemy.sObj[ i ];
					if( e == null || e.mAlive == 0 ){
						continue;
					}

					cmd( new byte[]{	MOV_RA,	BX,	(byte)( 0x20 + i << 1 )	}	);
					cmd( SP_setXYBX( (short)e.X, (short)e.Y ) );
					cmd( SP_drawBX() );
				}
				for( byte i = 0; i < 4; i++ ){
					cmd( new byte[]{	MOV_RA,	BX,	(byte)( 0x0a + ( i << 1 ) )	}	);
					cmd( PS_drawBX() );
				}
			}

			cmd( GX_SwapBuffers() );	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}

}
