class Program : System.Windows.Forms.Form
{
	public static byte[,]	Map = {
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
		{ 0, 0, 3, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },
		{ 0, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 3, 0, 3, 0, 0, },
		{ 0, 3, 3, 7, 7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 3, 6, 3, 6, 3, 0, },
		{ 0, 3, 3, 6, 6, 7, 7, 7, 2, 2, 2, 7, 7, 7, 7, 7, 7, 7, 6, 3, },
		{ 0, 0, 3, 3, 6, 6, 6, 7, 7, 2, 2, 2, 7, 7, 2, 2, 2, 7, 7, 6, },
		{ 0, 3, 3,10,11, 3, 3, 6, 7, 7, 2, 2, 2, 2, 2, 2, 1, 1, 7, 6, },
		{ 0, 0, 3, 3, 3, 0, 3, 3, 3, 7, 7, 2, 2, 2, 2, 7, 7, 1, 1, 6, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 7, 7, 7, 7, 2, 7, 6, 3, 1, 3, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 6, 6, 7, 2, 7, 6, 3, 1, 3, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 3, 6, 7, 7, 7, 6, 3, 1, 1, },
		{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 6, 6, 7, 7, 7, 6, 3, 1, },
	};

	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		TUGames.GZ.Init( this, 640, 360 );	//	自身、ウィンドウサイズ横、縦を指定してライブラリ初期化

		var		tp = TUGames.Texture.Create2p( new System.Drawing.Bitmap( "../assets/player.png" ) );	//	画像ファイルからテクスチャを生成
		var		tf = TUGames.Texture.Create2p( new System.Drawing.Bitmap( "../assets/field.png" ) );	//	画像ファイルからテクスチャを生成

		var		player = new TUGames.TexTile( tp, 2 );	//	テクスチャを横2分割されたタイルとして扱う（縦分割数は自動）
		var		tt = new TUGames.TexTile( tf, 4 );		//	テクスチャを横4分割されたタイルとして扱う（縦分割数は自動）
		var		field = new TUGames.PriTile( 20, 12, 32, 32, 1, tt ); //	桁数20、行数12、１タイル幅32、１タイル高さ32、レイヤー数1、テクスチャを指定してタイル状のプリミティブを生成
		field.setTexCoord( Map );

		int		px = 320, py = 240, an = 0;
		TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Left  ) ){	px--;	an = 2;	}	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Up    ) ){	py--;	an = 6;	}	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Right ) ){	px++;	an = 4;	}	//	引数で指定されたキーが押されている場合
			if( TUGames.PF.IsKeyDown( System.Windows.Forms.Keys.Down  ) ){	py++;	an = 0;	}	//	引数で指定されたキーが押されている場合
		},
		() =>{	//	描画処理
			TUGames.GZ.Clear();	//	設定された背景色で画面初期化

			//	マップ描画
			field.draw();

			//	プレイヤー
			player.drawRect( px, py, 1, 32, 32, an | ( ( px + py ) >> 4 & 1 ) );	//	座標XYZ, 幅高さWHで、指定したインデックスのタイルを描画

			TUGames.GZ.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示
		} );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
