"use strict";

var	WIDTH = 240;			//	仮想画面の幅
var	HEIGHT = 180;			//	仮想画面の高さ

let	mScore = 0;				//	得点
let	mWY = HEIGHT / 2;		//	壁穴のY座標
let	mDY = 0;				//	Y座標の移動差分
let	mKey = 0;				//	キー押下状態
let	mY = HEIGHT / 2;		//	プレイヤーのY座標
let	mGameOver;				//	ゲームオーバーかどうか
let	mWall = new Array( 8 );	//	壁座標


//	矩形(rect)領域内に点(x,y)が含まれるかどうか
function isContains( rect, x, y )
{
	return( rect[ 0 ] < x && x < rect[ 0 ] + rect[ 2 ] &&	//	X座標が範囲内かどうか
	        rect[ 1 ] < y && y < rect[ 1 ] + rect[ 3 ] );	//	Y座標が範囲内かどうか
}

//	壁を設置
function setWall( idx, x )
{
	mWY += TUGames.UT.Rnd( 41 ) - 20;	//	壁穴Y座標を前回位置から+-20の範囲で変更
	mWY = Math.min( mWY, HEIGHT - 40 );	//	壁穴Y座標上限チェック
	mWY = Math.max( mWY, 40 );			//	壁穴Y座標下限チェック
	mWall[ idx++ ] = [ x, 0       , 20, mWY - 20 ];		//	壁上部生成
	mWall[ idx   ] = [ x, mWY + 20, 20, 160 - mWY ];	//	壁下部生成
}

//	キーが押された場合のイベント
window.onkeydown = function()
{
	mKey = -0.25;		//	キー押下状態
}

//	キーが離された場合のイベント
window.onkeyup = function()
{
	mKey = 0.25;		//	キー押下状態
}

//	起動イベント
window.onload = function()
{
//	document.addEventListener( 'keydown', ( ev ) =>{	ev.preventDefault();	} );
//	document.addEventListener( 'keyup'  , ( ev ) =>{	ev.preventDefault();	} );

	TUGames.GX.Init( "main", WIDTH, HEIGHT, 3, -1 );	//	キャンバスIDと描画領域を指定してライブラリ初期化

	for( let i = 0, x = 100; i < 8; i += 2, x += 60 ){	//	壁を８つ生成
		setWall( i, x );	//	壁を設置
	}

	TUGames.PF.StartLoop( 30,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
	() =>{	//	更新処理
		if( mGameOver ){	//	ゲームオーバーの場合
			return;
		}

		mScore++;			//	得点加算
		mDY += mKey;		//	キー入力状態に応じてY方向移動量変更
		mY += mDY;			//	プレイヤーY座標変更
		if( mY < 0 || mY > HEIGHT ){	//	プレイヤーが画面の上下範囲外に達した場合
			mGameOver = true;			//	ゲームオーバー
		}
		for( let i = 0; i < mWall.length; i++ ){			//	全ての壁
			mWall[ i ][ 0 ] -= mScore / 256 + 0.25;			//	壁スクロール
			if( ( i & 1 ) == 1 && mWall[ i ][ 0 ] < -20 ){	//	下側の壁が画面左端を超えた場合
				setWall( i - 1, WIDTH );					//	新たに壁を設置
			}
			if( isContains( mWall[ i ], 45, mY ) ){			//	プレイヤーの中央座標と壁が重なった場合
				mGameOver = true;							//	ゲームオーバー
			}
		}
	},
	() =>{	//	描画処理
		TUGames.GX.Clear();	//	設定された背景色で画面初期化
		TUGames.GX.FillRect( 0, 0, WIDTH, HEIGHT, 0xffff0000 );	//	背景の矩形を描画
		TUGames.GX.FillRect( 40, mY - 5, 10, 10, 0xff00ffff );	//	プレイヤーの矩形を描画
		TUGames.GX.FillRects( mWall, 0xff00ff00 );				//	全ての壁の矩形を描画
		TUGames.GX.DrawString( "SCORE " + mScore, 0, 0, 0, 0xffffffff );	//	得点文字列を描画
		if( mGameOver ){	//	ゲームオーバーの場合
			TUGames.GX.DrawString( "GAME OVER", WIDTH / 2 - 18, HEIGHT / 2 - 2, 0, 0xffffffff );	//	ゲームオーバー文字列を描画
		}
		GL.flush();	//	描画内容を画面に反映
	} );
}
