"use strict";

var	WIDTH = 960;			//	仮想画面の幅
var	HEIGHT = 720;			//	仮想画面の高さ

let	mScore = 0;				//	得点
let	mWY = HEIGHT >> 1;		//	壁穴のY座標
let	mDY = 0;				//	Y座標の移動差分
let	mKey = 0;				//	キー押下状態
let	mY = HEIGHT >> 1;		//	プレイヤーのY座標
let	mGameOver;				//	ゲームオーバーかどうか
let	mWall = new Array( 8 );	//	壁座標


//	矩形(rect)領域内に点(x,y)が含まれるかどうか
function isContains( rect, x, y )
{
	return( rect[ 0 ] < x && x < rect[ 0 ] + rect[ 2 ] &&	//	X座標が範囲内かどうか
	        rect[ 1 ] < y && y < rect[ 1 ] + rect[ 3 ] );	//	Y座標が範囲内かどうか
}

//	壁を設置
function setWall( idx, x )
{
	mWY += TUGames.UT.Rnd( 161 ) - 80;		//	壁穴Y座標を前回位置から+-80の範囲で変更
	mWY = Math.min( mWY, HEIGHT - 160 );	//	壁穴Y座標上限チェック
	mWY = Math.max( mWY, 160 );				//	壁穴Y座標下限チェック
	mWall[ idx++ ] = [ x, 0       , 80, mWY - 80 ];		//	壁上部生成
	mWall[ idx   ] = [ x, mWY + 80, 80, 640 - mWY ];	//	壁下部生成
}

class Program extends TUGames.Client
{
	constructor()
	{
		super();

		this.cmd( TUGames.Client.GX_Init( WIDTH, HEIGHT, 0.75, 0 ) );	//	キャンバスIDと描画領域を指定してライブラリ初期化

		this.cmd( TUGames.Client.TF_Create() );
		this.cmd( new Uint8Array( [	TUGames.Client.MOV_AR,	0x00,	TUGames.Client.DX,	] ) );

		this.cmd( new Uint8Array( [	TUGames.Client.MOV_RA,	TUGames.Client.BX, 0x00,	] ) );
		this.cmd( TUGames.Client.PS_CreateBX( "SCORE " , 0     , 0, 0xffff, 0xffaa, 0xc000 ) );
		this.cmd( new Uint8Array( [	TUGames.Client.MOV_AR,	0x02,	TUGames.Client.DX,	] ) );

		this.cmd( TUGames.Client.PS_CreateBX( "0"      , 32 * 6, 0, 0xffff, 0xffaa, 0xc000 ) );
		this.cmd( new Uint8Array( [	TUGames.Client.MOV_AR,	0x04,	TUGames.Client.DX,	] ) );

		this.cmd( TUGames.Client.PS_CreateBX( "GAME OVER" , 32 * 10, 32 * 10, 0xffff, 0xffaa, 0xc000 ) );
		this.cmd( new Uint8Array( [	TUGames.Client.MOV_AR,	0x06,	TUGames.Client.DX,	] ) );

		for( let i = 0, x = 400; i < 8; i += 2, x += 240 ){	//	壁を８つ生成
			setWall( i, x );	//	壁を設置
		}

		TUGames.PF.StartLoop( 30,	//	fpsを指定してループを開始し、更新処理と描画処理を登録
		() =>{	//	更新処理
			if( mGameOver ){	//	ゲームオーバーの場合
				return;
			}

			mScore++;			//	得点加算
			mDY += mKey;		//	キー入力状態に応じてY方向移動量変更
			mY += mDY;			//	プレイヤーY座標変更
			if( mY < 0 || mY > HEIGHT ){	//	プレイヤーが画面の上下範囲外に達した場合
				mGameOver = true;			//	ゲームオーバー
			}
			for( let i = 0; i < mWall.length; i++ ){			//	全ての壁
				mWall[ i ][ 0 ] -= ( mScore >> 6 ) + 1;			//	壁スクロール
				if( ( i & 1 ) == 1 && mWall[ i ][ 0 ] < -80 ){	//	下側の壁が画面左端を超えた場合
					setWall( i - 1, WIDTH );					//	新たに壁を設置
				}
				if( isContains( mWall[ i ], 180, mY ) ){		//	プレイヤーの中央座標と壁が重なった場合
					mGameOver = true;							//	ゲームオーバー
				}
			}
		},
		() =>{	//	描画処理
			let	cm = TUGames.Client.GX_Clear();	//	設定された背景色で画面初期化
			cm = TUGames.UT.ConcatUint8Array( cm, TUGames.Client.GX_FillRect( 0, 0, WIDTH, HEIGHT, 0xf0 ) );	//	背景の矩形を描画
			cm = TUGames.UT.ConcatUint8Array( cm, TUGames.Client.GX_FillRect( 160, mY - 20, 40, 40, 0xcf ) );	//	プレイヤーの矩形を描画

			//	全ての壁の矩形を描画
			for( let i = 0; i < mWall.length; i++ ){
				let		w = mWall[ i ];
				cm = TUGames.UT.ConcatUint8Array( cm, TUGames.Client.GX_FillRect( w[ 0 ], w[ 1 ], w[ 2 ], w[ 3 ], 0xcc ) );
			}

			cm = TUGames.UT.ConcatUint8Array( cm, new Uint8Array( [	TUGames.Client.MOV_RA,	TUGames.Client.BX, 0x04,	] ) );
			cm = TUGames.UT.ConcatUint8Array( cm, TUGames.Client.PS_setStringBX( "" + mScore ) );

			cm = TUGames.UT.ConcatUint8Array( cm, new Uint8Array( [	TUGames.Client.MOV,	TUGames.Client.AH, TUGames.Client.PS_DRW,	] ) );
			if( mGameOver ){	//	ゲームオーバーの場合
				cm = TUGames.UT.ConcatUint8Array( cm, new Uint8Array( [
					TUGames.Client.MOV_RA,	TUGames.Client.BX,	6,
					TUGames.Client.INT,		TUGames.Client.PS,
				] ) );
			}
			for( let i = 1; i < 3; i++ ){
				cm = TUGames.UT.ConcatUint8Array( cm, new Uint8Array( [
					TUGames.Client.MOV_RA,	TUGames.Client.BX,	i << 1,
					TUGames.Client.INT,		TUGames.Client.PS,
				] ) );
			}

			cm = TUGames.UT.ConcatUint8Array( cm, TUGames.Client.GL_flush() );	//	描画内容を画面に反映

			this.cmd( cm );
		} );
	}
}

//	キーが押された場合のイベント
window.onkeydown = function()
{
	mKey = -1;		//	キー押下状態
}

//	キーが離された場合のイベント
window.onkeyup = function()
{
	mKey = 1;		//	キー押下状態
}

//	起動イベント
window.onload = function()
{
//	document.addEventListener( 'keydown', ( ev ) =>{	ev.preventDefault();	} );
//	document.addEventListener( 'keyup'  , ( ev ) =>{	ev.preventDefault();	} );
	new Program();
}

