"use strict";

var WIDTH  = 480;
var HEIGHT = 360;
var LENGTH = 64000;


var Car = class extends TUGames.Sprite
{
	constructor( textile, cidx )
	{
		super( 32, 64, textile, cidx, 1, 2 );
		this.mDX = 0;
		this.mSpeed = 0;
	}
}


var Enemy = class extends Car
{
	constructor( textile, spd )
	{
		super( textile, 25 );
		this.X = TUGames.UT.Rnd( 200 ) + 140 - 16;
		this.Y = -64;
		this.mDX = ( TUGames.UT.Rnd( 13 ) - 6 ) / 4.0;
		this.mSpeed = TUGames.UT.Rnd( spd ) + 10000;
	}
}


var Player = class extends Car
{
	constructor( textile )
	{
		super( textile, 24 );
		this.mBrake = 0;
		this.mSpeed = 6000;
		this.X = WIDTH / 2 - 16;
		this.Y = HEIGHT - 80;
	}

	tick()
	{
		if( TUGames.PF.IsKeyDown( 37 ) ){	//	引数で指定されたキーが押されている場合
			if( this.mDX == 0 ){
				this.X -= 2;
				this.mSpeed -= 50;
			}else if( this.mDX < 0 && this.mDX > -2 ){
				this.mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( 39 ) ){	//	引数で指定されたキーが押されている場合
			if( this.mDX == 0 ){
				this.X += 2;
				this.mSpeed -= 50;
			}else if( this.mDX > 0 && this.mDX < 2 ){
				this.mDX = 0;
			}
		}
		if( TUGames.PF.IsKeyDown( 90 ) ||
		    TUGames.PF.IsKeyDown( 40 ) ){	//	引数で指定されたキーが押されている場合
			this.mSpeed = Math.max( 6000, this.mSpeed - 500 );
			this.mBrake = true;
		}

		this.mSpeed += Math.min( 50, 1000000 / this.mSpeed );
		this.X += this.mDX;
		this.mDX -= Math.sign( this.mDX ) * Math.min( Math.abs( this.mDX ), 0.02 );
	}
}


var	Map =
[
	[
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
		[ 5, 5, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 4, 2, 1, 1, ],
	],[
		[ 9, 9,10,10,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, ],
		[ 9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, ],
		[ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, ],
		[ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, ],
		[ 9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, ],
		[ 9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, ],
		[ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, ],
		[ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, ],
		[ 9, 9,10,11,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, ],
		[ 9, 9,10,10,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, ],
		[ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, ],
		[ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, ],
		[ 9, 9, 9, 9,16,18, 8,20,21, 8,19,17, 9, 8, 8, 8, ],
		[ 9, 9, 9, 9,16, 8, 8, 8, 8, 8, 8,17, 9, 8, 8, 8, ],
		[ 9, 8, 8, 8,16,18, 8,20,21, 8,19,17, 8, 8, 8, 8, ],
		[ 9, 8, 8, 8,16, 8, 8, 8, 8, 8, 8,17, 8, 8, 8, 8, ],
	]                              
];

function start( im )
{
	TUGames.GX.Init( "main", 480, 360, 1, 8 );	//	キャンバスIDと描画領域を指定してライブラリ初期化

	let	tex = TUGames.Texture.Create( 0x80, 0x80 );
//	tex.texSubImage2D( 0x00, 0x00, TUGames.TURawImage.CreateFromImage( im[ 0 ], 16 ) );
//	tex.texSubImage2D( 0x00, 0x40, TUGames.TURawImage.CreateFromImage( im[ 1 ], 16 ).clone( 0, 20, 128, 60 ) );
	tex.texSubImage2D( 0x00, 0x00, im[ 0 ] );
	let	im2 = im[ 1 ].clone( 0, 24, 128, 48 );
	tex.texSubImage2D( 0x00, 0x40, im2 );

	let	ttc = new TUGames.TexTile( tex, 8, 0.5 / 8, 0.5 / 8 );
	let	field = new TUGames.BG( new TUGames.PriTile( 16, 16, 32, 32, 2, ttc ) );
	field.setIndex_A3( Map );

	let	tf = new TUGames.TexFont( new TUGames.TexTile( tex, 16, 8 / 128.0, 12 / 128.0, 0.0, 0.5 ) );
	tf.initHCode( 0x40, 0x20 );
	let	pt = [];
	pt[ 0 ] = TUGames.PriStr.Create( "TIME" , tf,  4, 28 * 1 + 6, 0xffffffff, 0xffffffff, 0xff000000 );
	pt[ 1 ] = TUGames.PriStr.Create( ""     , tf, 12, 28 * 2 + 6, 0xffffffff, 0xffffffff, 0xff000000 );
	pt[ 2 ] = TUGames.PriStr.Create( "SPEED", tf,  4, 28 * 4 + 6, 0xffffffff, 0xffffffff, 0xff000000 );
	pt[ 3 ] = TUGames.PriStr.Create( ""     , tf, 12, 28 * 5 + 6, 0xffffffff, 0xffffffff, 0xff000000 );

//	let	wo = new TUGames.TUWaveOut();

	let	player = new Player( ttc, 24 );
	let	enemy = [];

	let	py = 0;
	let	ani = -1;
	TUGames.PF.StartLoop( 60,	//	fpsを指定してループを開始し、更新処理と描画処理を登録	
//	TUGames.PF.StartLoop( 1,	//	fpsを指定してループを開始し、更新処理と描画処理を登録	
	()=>{	//	更新処理
		if( py - LENGTH > -0x200 && Map[ 1 ][ 0 ][ 4 ] == 16 ){	//	ゴール目前に迫った場合
			Map[ 1 ][ 0 ][  4 ] = 13;
			Map[ 1 ][ 0 ][  5 ] = 13;
			Map[ 1 ][ 0 ][  6 ] = 13;
			Map[ 1 ][ 0 ][  7 ] = 14;
			Map[ 1 ][ 0 ][  8 ] = 15;
			Map[ 1 ][ 0 ][  9 ] = 13;
			Map[ 1 ][ 0 ][ 10 ] = 13;
			Map[ 1 ][ 0 ][ 11 ] = 13;
			field.setIndex_A3( Map );
		}
		if( py - LENGTH > -0x200 + 276 ){	//	ゴールした場合
			player.mSpeed = 0;
			return;
		}

		let		tm = Math.floor( TUGames.PF.Count * 100 / 60 );
		let		st = "" + Math.floor( tm / 100 ) + "." + Math.floor( tm / 10 % 10 ) + ( tm % 10 );
		pt[ 1 ].setString( st.padStart( 6, ' ' ) );

		if( ani == 0 ){	//	衝突した場合
//			wo.playDB( exp );
			player.mSpeed = 0;
			player.setCClm( 2 );
			player.setWH( 64, 64 );
			player.setCIdx( 40 );
			player.X -= 16;
			ani = 1;
		}

		if( ani > 0 ){	//	爆発アニメ中の場合
			++ani;
			if( ( ani & 7 ) == 0 ){
				let	i = ani >> 2;
				if( i < 8 ){
					player.setCIdx( 40 + i );
				}
			}
			if( ani == 100 ){
				ani = -1;
				player.X = WIDTH / 2 - 16;
				player.setCClm( 1 );
				player.setWH( 32, 64 );
				player.setCIdx( 24 );
				player.mDX = 0;
				player.mSpeed = 1000;
			}
		}

		if( ( player.X < WIDTH / 2 - 16 - 112 || player.X > WIDTH / 2 - 16 + 112 ) && player.mSpeed >= 6000 && ani < 0 ){	//	壁に激突した場合
			ani = 0;
		}

		player.tick();
		if( ani >= 0 ){
			player.mSpeed = 0;
		}

		let		ps = Math.floor( player.mSpeed / 2.0 );
		let		s = Math.floor( ps / 100 ) + "." + ( Math.floor( ps / 10 ) % 10 ) + ( ps % 10 );
		pt[ 3 ].setString( s.padStart( 6, ' ' ) );

		if( ani < 0 ){
			py += player.mSpeed / 4096;
		}

		let	ds = player.mSpeed - 10000;
		if( ds > 1000 && TUGames.UT.Rnd( 30 + enemy.length * 40 ) == 0 ){
			enemy.push( new Enemy( ttc, ds ) );
		}

		for( let i = enemy.length - 1; i >= 0; i-- ){
			let	e = enemy[ i ];
			if( ani < 0 && player.isCollision( e ) ){
				let		dx = e.X - player.X;
				let		dy = e.Y - player.Y;
				let		ss = player.mSpeed;
				player.mSpeed = e.mSpeed;
				e.mSpeed = ss;
				player.mDX = -dx / 16;
				e.mDX = dx / 16;
			}
			e.X += e.mDX;
			e.Y += ( player.mSpeed - e.mSpeed ) / 4096;
			if( e.X > WIDTH / 2 + 112 - 16 && e.mDX > 0 ){
				e.mDX = -e.mDX;
			}
			if( e.X < WIDTH / 2 - 112 - 16 && e.mDX < 0 ){
				e.mDX = -e.mDX;
			}
			if( e.Y > 360 ){
				enemy.splice( i, 1 );
			}
		}

/*
		if( wo.getFlagDoneDB() ){
			if( !player.mBrake && player.mDX == 0 ){
				wo.playDB( TUGames.TUWaveOut.CreateSquare( player.mSpeed / 512.0f, 100, 0x2000 ) );
			}else{
				wo.playDB( bra );
				player.mBrake = false;
			}
		}

		if( wobgm.getFlagDoneDB() ){
			wobgm.playDB( wavbgm );
		}
*/
	},
	()=>{	//	描画処理
		TUGames.GX.Clear();	//	設定された背景色で画面初期化
		field.drawFull( -16, Math.floor( py - LENGTH ), WIDTH, HEIGHT );
		player.draw();
		for( let i = 0; i < enemy.length; i++ ){
			enemy[ i ].draw();
		}
		for( let i = 0; i < pt.length; i++ ){
			pt[ i ].draw();
		}
		GL.flush();	//	描画内容を画面に反映
	} );
}


window.onload = function()
{
//	document.addEventListener( 'keydown', ( ev ) =>{	ev.preventDefault();	} );
//	document.addEventListener( 'keyup'  , ( ev ) =>{	ev.preventDefault();	} );

/*	セキュリティ対策への対策
	let	fn = [ "../assets/8x8_4c_2bpp.png", "../assets/font_8x10.png" ];
	let	im = new Array( fn.length );
	let	cnt = 0;
	for( let i = 0; i < fn.length; i++ ){
		im[ i ] = new Image();
		im[ i ].onload = function()
		{
			if( ++cnt == fn.length ){
				start( im );
			}
		}
		im[ i ].src = fn[ i ];
	}
*/

	let	im = new Array( 2 );
	im[ 0 ] = TUGames.TUPicture.CreateFromBin( new Uint8Array( [
		0x54,0x55,0x50,0x20,0x31,0xa4,0x40,0x00,0x40,0x00,0x0e,0x00,0x00,0xf0,0x00,0x50,
		0xf0,0x05,0xa0,0xf0,0x0a,0xf0,0xf0,0x0f,0x55,0x05,0xf5,0x5f,0x0f,0xfa,0xaf,0xff,
		0xff,0x00,0x00,0x08,0x00,0x08,0x00,0x9b,0x00,0x9b,0x00,0xbd,0x00,0xbd,0x00,0x46,
		0x00,0x46,0x00,0x7d,0x00,0x7d,0x00,0x13,0x00,0x13,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x08,0x00,0x08,0x00,0x9b,0x00,0x9b,0x00,0xbd,0x00,0xbd,0x00,0x46,
		0x00,0x46,0x00,0x7d,0x00,0x7d,0x00,0x13,0x00,0x13,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x42,0x66,0x42,0x66,0xc4,0x01,0xa4,0x00,0x32,
		0x00,0x32,0x0d,0x00,0x00,0x00,0x00,0xd0,0x00,0xd0,0x00,0xd0,0x00,0xd0,0x00,0xd0,
		0x00,0xd0,0x00,0x00,0x00,0x00,0x00,0x52,0x44,0x52,0x44,0xd4,0x07,0xc4,0x05,0xdc,
		0x00,0xdc,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0xdd,0x00,0xdd,
		0x00,0xdd,0x00,0x00,0x00,0xdd,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0xdd,
		0x00,0x00,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0xdd,
		0x00,0x00,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0xdd,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0xd1,0x00,0xd1,0x00,0xdb,0x00,0xdb,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x01,0x0d,0x01,0x0d,0x0b,0x0d,0x0b,0x0d,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x0b,0x00,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x10,0x0d,0x10,0x0d,0xb0,0x0d,0xb0,0x0d,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0xd0,0x00,0x10,0x00,0x10,0x00,0x00,0x00,0x10,0x00,0x10,0x00,0x10,
		0x00,0x00,0x00,0x00,0x00,0xd0,0x00,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x10,0x00,0x53,0xdd,0x31,0x55,0x10,0x00,0x10,0x03,0x53,0x01,0x13,
		0x05,0x10,0x00,0xd0,0x00,0x10,0x00,0x10,0x00,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x10,0x03,0x75,0x33,0x53,0xdd,0x10,0x00,0x01,0x03,0x53,0x00,0x15,
		0x03,0x10,0x00,0xd0,0x00,0x01,0x00,0x01,0x00,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0xd0,0x00,0x10,0x03,0x10,0x00,0x00,0x00,0x10,0x00,0x10,0x00,0x10,
		0x00,0x00,0x00,0x00,0x00,0xd0,0x00,0xd0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x51,0x45,0x54,0x55,0x45,
		0x55,0x55,0x45,0x54,0x51,0x55,0x15,0x15,0x54,0x55,0x45,0x00,0x04,0x00,0x40,0x00,
		0x04,0x00,0x40,0x55,0x51,0x55,0x44,0x55,0x45,0x54,0x45,0x00,0x04,0x00,0x40,0x00,
		0x04,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x55,0x54,0x55,0x15,
		0x54,0x55,0x51,0x51,0x55,0x05,0x54,0x55,0x51,0x55,0x15,0x00,0x00,0x04,0x00,0x00,
		0x01,0x00,0x00,0x55,0x51,0x15,0x54,0x54,0x45,0x55,0x51,0x00,0x04,0x00,0x00,0x10,
		0x00,0x01,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0x94,0x50,0xe4,0xe3,
		0x94,0x50,0xe4,0xdf,0xcb,0xb3,0x3d,0xff,0xc7,0x73,0x3f,0x0f,0x53,0x54,0x00,0xf0,
		0xc5,0x11,0x08,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x44,0x11,0xff,0xff,0x44,
		0x11,0xff,0xff,0x44,0x11,0xff,0x57,0x44,0x11,0xff,0xdf,0x44,0x11,0xff,0xdf,0x44,
		0x11,0xff,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x88,0x90,0xd3,0x54,0x88,
		0x90,0xd3,0x54,0xdc,0xcf,0xfb,0xf3,0xdf,0xcd,0xf8,0xf3,0x53,0x93,0x53,0x03,0xc5,
		0xc9,0xc9,0xc0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xfc,0x0c,0x3c,0x03,0x33,0x33,0x33,0xcf,0x33,0x03,0x33,0x33,0xf3,
		0xf3,0xf3,0x03,0xff,0xff,0xff,0xff,0xfc,0xfc,0xfc,0xfc,0x3f,0x3f,0x3f,0x3f,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0xfc,0xfc,0xfc,0xfc,0xff,
		0xff,0xff,0xff,0xcf,0xcf,0xcf,0xcf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf3,
		0xf3,0xf3,0xf3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfc,0xfc,0xfc,0xfc,0x3f,0x3f,0x3f,0x3f,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3f,0x3f,0x3f,0x3f,0xfc,0xfc,0xfc,0xfc,0xff,
		0xff,0xff,0xff,0xcf,0xcf,0xcf,0xcf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf3,
		0xf3,0xf3,0xf3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x07,0x01,0x00,0x00,0xd0,0x40,0x00,0x00,0x07,0x01,0x00,0x00,0xd0,
		0x40,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x50,0x54,0x56,0x51,0x05,0x15,0x95,0x45,0x50,0x54,0x56,0x51,0x05,
		0x15,0x95,0x45,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x05,0x05,0x05,0x51,0x50,0x50,0x50,0x45,0x05,0x05,0x05,0x51,0x50,
		0x50,0x50,0x45,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x01,0x55,0xa9,0x57,0x40,0x55,0x6a,0xd5,0x01,0x55,0xa9,0x57,0x40,
		0x55,0x6a,0xd5,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0x0f,0xff,0x0f,0x40,0x55,0xff,0xfc,0xf0,0x05,0xff,
		0xff,0xff,0xff,0xff,0xff,0x0f,0x43,0xff,0x03,0x50,0x55,0xff,0xf0,0xc1,0x05,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x03,0xff,0xff,0xff,0x00,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x43,0x53,0x53,0xd3,0x00,0x50,0x57,0xa5,0xc1,0x0a,0x1a,0x6a,0xf0,
		0xf3,0xf1,0xc1,0xd3,0x53,0x91,0x91,0x0a,0x00,0x5c,0x54,0x50,0x40,0x4a,0x5a,0xfc,
		0xf1,0xc0,0xc1,0xff,0xff,0x3f,0x3f,0x40,0x70,0x54,0x54,0x03,0x15,0x15,0x15,0xfc,
		0xfc,0xf0,0xf0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x93,0x93,0x83,0x4f,0x54,0x5c,0x02,0x0a,0x1a,0x16,0x05,0xc0,0xc1,
		0x30,0x3c,0xff,0x81,0x81,0x81,0x81,0x54,0x43,0x0c,0x00,0x50,0x58,0xd6,0xd6,0x01,
		0x01,0x00,0xfc,0x3f,0x3f,0x3f,0xff,0x01,0x01,0x15,0x55,0x40,0x00,0x40,0x55,0xf0,
		0xf0,0xfc,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0x3f,0x3f,0xff,0xff,0xa5,0x50,0x03,0xff,0xc7,0xc1,0xf0,0xff,0xff,
		0xff,0xff,0xff,0x50,0x03,0x3f,0xff,0x55,0x55,0x70,0x03,0x05,0x01,0xf0,0xfc,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x0f,0xff,0xff,0xff,0xc0,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,
	] ) );
	im[ 1 ] = TUGames.TUPicture.CreateFromBin( new Uint8Array( [
		0x54,0x55,0x50,0x20,0x31,0xa3,0x80,0x00,0xc0,0x00,0x01,0x00,0xff,0x0f,0x00,0x00,
		0x83,0xed,0xf7,0xfb,0xbb,0xe5,0xf7,0xfb,0x83,0xe9,0xf3,0xfb,0xbb,0xeb,0x48,0x80,
		0x83,0xeb,0xe9,0xf3,0xbb,0xf3,0xc9,0xc1,0xbb,0xf3,0xd8,0xf9,0xbd,0xe1,0xf1,0xf8,
		0xff,0xff,0xf7,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xf7,0xff,0xfb,0xff,0xf7,0xff,0xfb,0xff,0xf7,0xff,0xfb,0xff,0xf7,0xff,0xfb,
		0x43,0x06,0x00,0xf8,0xd9,0xf0,0xfb,0xfb,0xdd,0xff,0xf9,0xfb,0xdd,0xff,0xfd,0xfb,
		0xdd,0xff,0xf9,0xfb,0xfd,0xff,0xfb,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xd7,0xdb,0xff,0xef,0xd7,0xdb,
		0xff,0xef,0xff,0xc1,0xff,0xef,0xff,0x9b,0xff,0xef,0xff,0xdb,0xff,0xef,0xff,0x19,
		0xe7,0xf7,0xf9,0xfd,0xc7,0xf7,0xc5,0xe1,0x9b,0xc1,0xdd,0xf5,0xfb,0xf7,0xdd,0xe5,
		0xc5,0xf7,0xd9,0xe3,0xe3,0xf7,0xc1,0xeb,0xc7,0xf7,0xdd,0xe1,0x21,0xc1,0xd9,0xe3,
		0x83,0xdf,0xc7,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xfd,0xf7,0xfb,0xff,0xfd,0xf7,0xfb,0xff,0xfd,0xf7,0xfb,0xff,0xfd,0xf7,0xfb,0xff,
		0x00,0x80,0x73,0xc0,0xfe,0xf7,0xf7,0xdf,0xfe,0xf7,0xf7,0xff,0xfc,0xf3,0xe7,0xff,
		0xfd,0xfb,0xef,0xff,0xf9,0xfb,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xbb,0xf1,0xfb,0x87,0xb9,0xe5,0xf3,
		0xe3,0x99,0xed,0xf7,0xeb,0xcf,0xe5,0xf7,0xc3,0xe7,0xf3,0xff,0x8f,0xd3,0xc3,0xff,
		0xff,0xff,0xdb,0xfb,0xf1,0xed,0xdb,0xeb,0xc5,0xc1,0x99,0xeb,0xc5,0xe1,0xb1,0xc1,
		0xc1,0xe5,0xc7,0x81,0xdd,0xc1,0xd7,0x0b,0xdd,0xc3,0xd3,0xdb,0xdd,0xcf,0xcf,0xeb,
		0xdd,0xcf,0xff,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xfb,0xfb,0xff,0xff,0xfb,0xfb,0xff,0xff,0xfb,0xfb,0xff,0xff,0xfb,0xfb,
		0xef,0xf9,0xfb,0xfb,0xe1,0xe3,0x03,0xf8,0xfd,0xef,0xff,0x3f,0xf9,0xe7,0xff,0xbf,
		0xfb,0xf7,0xff,0xbf,0xfb,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xef,0xef,0xf7,0x6e,0xef,0xef,0xe7,0xad,0xef,
		0xf7,0xef,0xcb,0xef,0xf7,0xef,0xe7,0x01,0xf7,0xef,0xe7,0xef,0xe7,0xef,0xcb,0xef,
		0xff,0xcf,0xc0,0xff,0xc1,0xf0,0xf7,0xff,0xf7,0xf7,0xe7,0xff,0xf3,0xd7,0x8b,0xff,
		0x89,0xc0,0xbb,0xff,0xbb,0xfb,0xd9,0xff,0x83,0xfb,0xdd,0xff,0xc3,0xf3,0xcd,0xff,
		0xef,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xf7,0xfb,0xfb,0xde,0xf7,0xfb,0xf7,0xec,0x77,0xfb,0xf7,
		0xf1,0x00,0xe0,0xd5,0xf8,0xf7,0xea,0xd4,0xf3,0x67,0xe0,0x96,0xe7,0xc3,0xfb,0xb6,
		0xcf,0x99,0xfb,0xf7,0xdf,0xbc,0xfb,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbf,0xff,0xff,0xff,0xdf,0xff,0xff,0xff,0xdf,
		0xff,0xff,0xff,0xef,0xff,0x81,0xff,0xef,0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xf7,
		0xff,0xff,0xff,0xc1,0xff,0xef,0xff,0xdb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xc3,0xef,0xc3,0xc3,0xbd,0xe7,0xbd,0xbd,0xbd,0xeb,0xbf,0xbf,
		0x9d,0xef,0xbf,0xbf,0xad,0xef,0xdf,0xc7,0xb5,0xef,0xef,0xbf,0xb9,0xef,0xf7,0xbf,
		0xbd,0xef,0xfb,0xbf,0xbd,0xef,0xfd,0xbd,0xc3,0x83,0x81,0xc3,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xe7,0xe1,0xe7,0xff,0xdb,0xdd,0xdb,0xff,0xdb,0xbd,0xbd,
		0xff,0xbd,0xbd,0xfd,0xff,0xbd,0xc1,0xfd,0xff,0x81,0xbd,0xfd,0xff,0xbd,0xbd,0xfd,
		0xff,0xbd,0xbd,0xbd,0xff,0xbd,0xbd,0xdb,0xff,0xbd,0xc1,0xe7,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xc1,0xc3,0xc1,0xc3,0xbd,0xbd,0xbd,0xbd,0xbd,0xbd,0xbd,0xbd,
		0x87,0x99,0xc1,0xff,0xe1,0x9d,0xd1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xdf,0x81,0xc7,0x81,0xcf,0xfd,0xfb,0xbd,0xd7,0xfd,0xfd,0xbd,
		0xd7,0xfd,0xfd,0xbf,0xdb,0xc1,0xc1,0xdf,0xdb,0xbf,0xbd,0xdf,0xdd,0xbf,0xbd,0xef,
		0x81,0xbf,0xbd,0xef,0xdf,0xbd,0xbd,0xf7,0xdf,0xc3,0xc3,0xf7,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xe1,0x81,0x81,0xc7,0xdd,0xfd,0xfd,0xbb,0xbd,0xfd,0xfd,0xfd,
		0xbd,0xfd,0xfd,0xfd,0xbd,0xc1,0xc1,0x8d,0xbd,0xfd,0xfd,0xbd,0xbd,0xfd,0xfd,0xbd,
		0xbd,0xfd,0xfd,0xbd,0xdd,0xfd,0xfd,0xbb,0xe1,0x81,0xfd,0xc7,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0x81,0xbd,0xbd,0xbd,0xef,0xbd,0xbd,0xbd,0xef,0xbd,0xbd,0xbd,
		0xef,0xe7,0xad,0xef,0xcf,0xf3,0x6e,0xef,0xff,0xff,0xef,0xef,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xc3,0xc3,0xff,0xff,0xbd,0xbd,0xff,0xff,0xbd,0xbd,0xef,0xef,
		0xbd,0xbd,0xff,0xff,0xc3,0xbd,0xff,0xff,0xbd,0x83,0xff,0xff,0xbd,0xbf,0xff,0xff,
		0xbd,0xbf,0xef,0xef,0xbd,0xdf,0xff,0xef,0xc3,0xe3,0xff,0xf7,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xbd,0x83,0x87,0xbd,0xbd,0xef,0xdf,0xdd,0xbd,0xef,0xdf,0xed,
		0xbd,0xef,0xdf,0xf5,0x81,0xef,0xdf,0xf9,0xbd,0xef,0xdf,0xf9,0xbd,0xef,0xdf,0xf5,
		0xbd,0xef,0xdd,0xed,0xbd,0xef,0xdd,0xdd,0xbd,0x83,0xe3,0xbd,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xbd,0xbd,0x81,0xff,0xbd,0xbd,0xbf,0xe7,0xdb,0xbb,0xdf,0xf7,
		0xe7,0xff,0xe7,0xfb,0xe7,0xff,0xe7,0xfb,0xef,0xff,0xff,0xfd,0xf3,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xbf,0xff,0xfd,0xc3,0xdf,0xff,0xfb,0xbd,0xef,0x81,0xf7,0xbd,
		0xf7,0xff,0xef,0xbf,0xfb,0xff,0xdf,0xdf,0xfb,0xff,0xdf,0xef,0xf7,0xff,0xef,0xef,
		0xef,0x81,0xf7,0xef,0xdf,0xff,0xfb,0xff,0xbf,0xff,0xfd,0xef,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xfd,0xbd,0xbd,0xc3,0xfd,0x99,0xb9,0xbd,0xfd,0x99,0xb9,0xbd,
		0xfd,0x85,0xb5,0xbd,0xfd,0xad,0xb5,0xbd,0xfd,0xad,0xad,0xbd,0xfd,0xbd,0xad,0xbd,
		0xfd,0xbd,0x9d,0xbd,0xfd,0xbd,0x9d,0xbd,0x81,0xbd,0xbd,0xc3,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xc7,0xe7,0xff,0xbb,0xdf,0xe7,0xff,0xdb,0xdf,0xc3,0xff,
		0xbd,0xbd,0xbd,0xfd,0xbd,0xbd,0xbd,0xc3,0xc1,0xbd,0xc1,0xbf,0xfd,0xbd,0xed,0xbf,
		0xfd,0xb5,0xdd,0xbf,0xfd,0xcd,0xdd,0xbd,0xfd,0xe3,0xbd,0xc3,0xff,0x9f,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0xff,0xff,0xc3,0xfd,0xff,
		0xff,0xbf,0xfd,0xff,0xff,0xa7,0xf1,0xe3,0xff,0x83,0xe5,0xf9,0xff,0xbb,0xcd,0xfd,
		0xff,0xb3,0xe5,0xfb,0xff,0x87,0xf1,0xe3,0xff,0x3f,0xff,0xff,0xff,0xff,0xff,0xff,
		0xfd,0xcf,0xff,0xff,0xe1,0x87,0xfd,0xff,0xed,0x9b,0xf1,0xe1,0xed,0x8b,0xf9,0xfc,
		0xe1,0xcb,0xf9,0xf0,0xfd,0xc3,0xfd,0x8f,0xf9,0xdf,0xfd,0x9f,0xf9,0xdf,0xff,0xc1,
		0xfd,0xdf,0xff,0xff,0xf7,0xff,0xf3,0xff,0xc3,0x99,0xe3,0xe7,0x81,0x81,0xe1,0xe7,
		0xef,0xbd,0xbb,0xad,0xef,0xbd,0xdb,0xad,0xef,0xbd,0xdb,0xad,0xef,0xbd,0xd7,0xa5,
		0xef,0xbd,0xd7,0x95,0xef,0xbd,0xe7,0xdb,0xef,0xc3,0xef,0xdb,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xdf,0xff,0xc7,0xff,0xdf,0xff,0xf7,0xff,
		0xdf,0xc3,0xf7,0xff,0xc7,0xd9,0xe1,0xc3,0xd3,0xc1,0xc3,0x93,0xdb,0xfd,0xfb,0x87,
		0xd7,0xfd,0xfb,0x9f,0xc7,0xc1,0xf3,0xdb,0xff,0xf3,0xff,0xc3,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xef,0xff,0xff,0xff,0xcb,0x9f,0xff,0xff,0xe3,0x9b,0xdb,0xb1,
		0xef,0x9b,0xdb,0xb1,0xef,0x9b,0xeb,0xa1,0xef,0x9b,0xe3,0x89,0xef,0xc3,0xe7,0xd9,
		0xcf,0xff,0xff,0xfb,0xff,0xff,0xff,0xff,0xff,0xc7,0xef,0xff,0xff,0x03,0xef,0xff,
		0xdb,0xdb,0xdf,0xf7,0xe7,0xd7,0xef,0xf7,0xe7,0xe7,0xe7,0xf7,0xdb,0xef,0xf7,0xf7,
		0xdb,0xef,0xfb,0xf7,0xbd,0xef,0xfd,0xe7,0xbd,0xef,0x81,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xff,0xff,0xfd,0xf3,0xff,0xff,0xfd,
		0xf7,0xf7,0xef,0xfd,0xf7,0xff,0xff,0xe5,0xf3,0xf7,0xef,0xf1,0xc3,0xf7,0xef,0xf9,
		0xd9,0xf7,0xee,0xe5,0xdb,0xf7,0xec,0xed,0xdb,0xff,0xe1,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0x81,0xef,0xff,0xff,0xbf,0xe7,0xbb,0xbf,0xdf,0xf3,0xbb,0xbd,0xef,0xf3,
		0xd7,0x99,0xf7,0xf7,0xc7,0xc3,0xfb,0xf3,0xef,0xef,0xfd,0xf7,0x87,0xe3,0x81,0xf7,
		0x33,0xfb,0xff,0xe7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xc7,0xdf,0xff,0xff,0xe3,0xdf,0xff,0xff,0x87,0xdf,0xff,0xff,0xe9,0xdf,0xff,0xff,
		0x83,0xdf,0xff,0xff,0xef,0xc7,0xff,0xc1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xf7,0xff,0xff,0xc7,
		0xf7,0x9c,0x83,0x99,0xf3,0x91,0xb3,0x3d,0xf3,0x91,0xb3,0x3d,0xf7,0x81,0xb3,0xb9,
		0xf7,0x21,0xb3,0x9b,0xe7,0x25,0xfb,0xe3,0xff,0xe7,0xff,0xff,0xff,0xff,0xff,0x00,
		0xef,0xc7,0xff,0x00,0xef,0xdf,0xa3,0x00,0xef,0xdf,0x8b,0x00,0xff,0xcf,0xff,0x00,
		0xff,0x8f,0xff,0x00,0xef,0xef,0xff,0x00,0xef,0xcf,0xff,0x00,0xef,0xc7,0xff,0x00,
		0xff,0xff,0xff,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0x01,0x81,0x81,0xc3,0x01,0x81,0x81,0x81,0x01,0x81,0x81,0x81,0x01,0x81,0xf7,0xc1,
		0xc3,0x83,0xf7,0xc3,0xc7,0xc7,0xf7,0xe3,0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xe3,
		0xff,0xc1,0xfd,0xff,0xff,0xf7,0xdd,0xc3,0xff,0xd7,0xbd,0xbd,0xff,0xc3,0xbd,0xbf,
		0xff,0x95,0xbd,0xbf,0xff,0xa5,0xbd,0xdf,0xff,0xb5,0xb5,0xef,0xff,0xeb,0xfb,0xf7,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0xff,0xff,0xff,0xfb,0xff,
		0xff,0xff,0xfb,0xef,0xff,0xe3,0xfb,0xef,0xff,0xeb,0xfb,0xef,0xff,0xe3,0xff,0xf1,
		0xff,0xff,0xff,0xf3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc7,0xff,0xff,
		0xe3,0xd1,0xef,0xf7,0xff,0xd7,0xf7,0xf6,0xff,0xc7,0xf3,0xe0,0xff,0xf3,0xf0,0xce,
		0x81,0x03,0xe3,0xf7,0xbd,0x03,0xce,0xf7,0xbd,0x03,0xe6,0x83,0xbd,0x03,0xe6,0x93,
		0xb1,0x07,0xf3,0x93,0x87,0x87,0xe3,0x83,0xff,0xff,0x9f,0xe3,0xff,0xff,0xff,0xff,
		0xe3,0xef,0xef,0xef,0xcf,0xef,0xaf,0xef,0x9f,0xc3,0x63,0xc7,0x81,0x07,0x4f,0xd3,
		0xcf,0x67,0xcf,0xc7,0xe3,0x27,0xc3,0xdb,0xe9,0xa7,0xef,0xf3,0x8d,0xf7,0xff,0xe7,
		0xff,0xff,0xff,0xff,0xff,0xff,0xc7,0xff,0xff,0xff,0x9f,0xff,0xff,0xff,0xb7,0xc7,
		0xff,0xff,0x87,0xd7,0xf3,0xff,0xdf,0xc7,0xe7,0xef,0xcf,0xf7,0xef,0xff,0xef,0xf7,
		0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbf,0xbf,0xe7,
		0x81,0xbf,0xbf,0xef,0xef,0x03,0xa7,0xc3,0xef,0xbf,0x0f,0xef,0xef,0x9f,0x5f,0x03,
		0xff,0xff,0xff,0xfb,0xff,0xe3,0xf3,0xfb,0x9d,0xff,0xe7,0xf1,0xbd,0xe3,0xe3,0xe3,
		0x7d,0xef,0xc1,0xe9,0x79,0xe7,0xe4,0xe9,0xff,0xff,0xff,0xff,0xef,0xff,0xff,0xf7,
		0xef,0xff,0xff,0xf7,0xf7,0xdd,0xe1,0xf1,0xfb,0xd3,0xef,0xf3,0xf9,0x8b,0xff,0xf7,
		0xf3,0xdb,0xff,0xf5,0xcf,0xdb,0xff,0xf9,0xdf,0xcb,0xf9,0xc7,0xff,0xeb,0xf3,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xef,0xef,0xff,0xf7,
		0xe7,0xeb,0xc1,0xe1,0xf3,0x83,0xf7,0xe7,0xf1,0xbb,0xf7,0xf1,0xf6,0xdf,0xc1,0xf7,
		0xf7,0xef,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe1,0xfb,0xe1,0xfb,
		0xcd,0xfb,0xcf,0xeb,0xdd,0xf9,0xdf,0xc1,0xcd,0x04,0xdf,0xeb,0xec,0xde,0xdf,0xeb,
		0xef,0xed,0xf7,0xff,0x83,0xc5,0xf7,0xc3,0xa1,0xc1,0xc7,0x9f,0x97,0xc1,0xf7,0xbf,
		0xe7,0xe7,0x83,0x8f,0xef,0xff,0xf3,0xe7,0xff,0xef,0xff,0xff,0xff,0xef,0xff,0xff,
		0xfb,0x03,0xd7,0xdb,0xfb,0xef,0xd3,0xc7,0xfb,0xef,0x83,0xc3,0xfb,0xe3,0xcf,0xe9,
		0xdb,0xe3,0xef,0xe7,0xc3,0xe3,0x8f,0xc7,0xff,0xe3,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xff,0xe7,0xab,0xcb,0xc3,0x8f,0xab,
		0xc3,0xdf,0xbf,0xaf,0xd3,0xdf,0x07,0x9f,0xf7,0xd9,0xbf,0xcf,0xe7,0x07,0x87,0xe7,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xf9,0xe3,0xef,0xb7,0xf3,0x0f,0xef,0xb7,0xff,0x9f,0x01,0xaf,0x79,0xc7,0x6f,0x8f,
		0xff,0xfb,0xf7,0xe7,0xff,0xfb,0xf3,0xf3,0xff,0xff,0xfb,0xf9,0xff,0xff,0xfb,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x91,0xcf,0xea,0xf0,0x81,0xf3,0xea,0xff,
		0xd9,0xef,0xe2,0xee,0xd1,0xec,0xef,0xe0,0xd7,0xc1,0xef,0xfb,0xef,0xef,0xe7,0xfb,
		0xe7,0xef,0xf3,0xfb,0xf3,0xe7,0xf9,0xfd,0xff,0xf7,0xfd,0xfc,0xff,0xff,0xff,0xfe,
		0xc1,0xfd,0xff,0xff,0xdf,0xfd,0x6f,0xf8,0xfb,0xfd,0xe6,0xfd,0xe3,0xfd,0x75,0xfd,
		0xff,0xfe,0x73,0xf0,0xe1,0xce,0xe1,0xfe,0x4f,0x80,0xfc,0xfe,0xff,0xdf,0xfe,0xf0,
		0xff,0xff,0xff,0xff,0xfb,0xf7,0xff,0xff,0xe1,0xf7,0x7f,0xff,0xf3,0xc1,0x4f,0x70,
		0xcb,0xfb,0xc0,0xf7,0xd3,0x83,0xdf,0xfb,0xf3,0xbf,0xdf,0xfb,0xeb,0xdf,0xef,0xfd,
		0xef,0x9f,0x4f,0xef,0xe7,0xaf,0x6f,0xef,0xf6,0x87,0x37,0xef,0x81,0xdf,0xff,0xef,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0x9f,0xcf,0xfb,0xfd,0xbf,0x1f,0x03,
		0xfd,0x03,0xff,0x7f,0xfd,0xbf,0xff,0x27,0xf0,0xbf,0xff,0x9f,0xc6,0x8f,0xff,0x2f,
		0xfe,0xe7,0x07,0xe6,0xfc,0xff,0xff,0xf7,0xf9,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xfd,0xff,0xff,0xe7,0xfd,0xf3,0x07,0x0e,0xe1,0xc7,0xff,0xf6,0xe4,0xdf,0xe7,0x06,
		0xf9,0xdf,0x1f,0xfe,0xfb,0xdf,0xff,0x7e,0xfb,0x03,0xee,0x7e,0xf3,0xff,0x0f,0x9f,
		0xff,0xff,0xff,0xdf,0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xf7,0x21,0xf7,0xff,
		0xf2,0x7b,0x36,0xec,0xf8,0xdb,0xf7,0xef,0xfd,0xdf,0xf7,0x0f,0xfd,0x9f,0xf7,0x5f,
		0xef,0xdf,0xdf,0xef,0xe7,0xcf,0xcf,0xef,0xf3,0xef,0xef,0xe3,0xfb,0xef,0xe1,0xff,
		0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xfd,0xe7,0xbf,0xff,0xfd,0xcf,0xbf,0xe5,0xfd,
		0x83,0xbf,0xed,0xc1,0x9f,0xdf,0xed,0xfd,0xc3,0xcf,0xcd,0xfd,0xcd,0xf7,0xdd,0xf9,
		0x2f,0xf3,0x9d,0xfb,0x6f,0xff,0xbf,0xc3,0xef,0xff,0xff,0xff,0xff,0xff,0xfb,0xff,
		0xff,0xff,0xf3,0xfe,0x77,0xd7,0xf7,0xf9,0x77,0xd7,0xf7,0xe1,0x76,0xd7,0x95,0xed,
		0x76,0xd7,0xc6,0xed,0x3e,0xdb,0xe6,0xed,0x9f,0x5b,0xf7,0xed,0xdf,0x9f,0xff,0xec,
		0xff,0xff,0xff,0xe1,0xff,0xff,0xff,0xff,0xff,0xff,0xdd,0xff,0xee,0x8f,0xdd,0xf3,
		0x66,0x36,0x84,0xf5,0x0e,0xb6,0xbc,0xe7,0xcc,0x96,0xbd,0xc3,0xe5,0xd6,0xbc,0xd3,
		0x23,0xe3,0x2f,0x9f,0x8f,0xdd,0xef,0xcf,0x9f,0xde,0xcf,0xf3,0xc1,0xbf,0x9f,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0xff,0xdf,0xff,0xfb,0xff,0xdf,0x87,
		0x87,0xef,0x03,0xbf,0xbf,0xc5,0xd7,0x9f,0xdf,0xd1,0x37,0xd7,0xef,0xdf,0x97,0xc6,
		0xef,0x9f,0xdf,0x9e,0xf7,0xff,0xdf,0xff,0xfb,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xf3,0xff,0xff,0xff,0x85,0xfb,0xf7,0xdf,0xbd,0xe7,0xd7,0xc7,0xbf,0xff,0x97,0xd7,
		0xdf,0xff,0xbf,0xd7,0xdf,0xbf,0xff,0xc7,0xef,0x9f,0xff,0xff,0xef,0xcb,0xff,0xff,
		0xf7,0xe3,0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xef,0xff,0xff,0x8b,0xc3,
		0xfb,0xf3,0xab,0x8f,0xf7,0xe1,0x8b,0xef,0xf3,0xcd,0xbb,0x8b,0xd7,0x9f,0x0b,0xe3,
		0x1f,0xc7,0xe3,0xf3,0x7f,0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xe7,0xef,0xff,0xf7,
		0xef,0x6f,0xd7,0xf7,0x63,0xe3,0xd6,0xe1,0x4b,0xef,0x00,0xf7,0x2b,0xe7,0x55,0xf4,
		0x25,0xe7,0x46,0xf1,0xb1,0xe7,0x62,0xa3,0xb3,0x2f,0x28,0x8f,0xf3,0x8f,0xff,0xff,
		0xf3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xc1,0x07,0xb7,0x1f,0xff,0xe3,0x27,0x9e,0xff,0xf3,0xff,0xff,0xff,0xff,0xef,0xff,
		0xf2,0xfd,0xcf,0xbf,0xc5,0x85,0x1f,0x7e,0xc0,0xa1,0xdf,0xdf,0xdd,0x81,0xdf,0x1f,
		0xfd,0xe1,0xdf,0x9f,0xf9,0xed,0x03,0xfe,0xfb,0xef,0xc3,0x7c,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0x68,0xd7,0x04,0xf3,0x28,0x46,0xd4,0xf3,0x3f,0xff,0xc7,0xff,0xbf,0xff,0xff,0xff,
		0xff,0x0f,0xf7,0xe3,0xff,0x7e,0xe7,0xef,0x5f,0xbe,0x2f,0xf7,0x50,0x0f,0x0f,0xe3,
		0x57,0x6f,0x8f,0xe9,0x31,0x7f,0xa7,0xef,0xbc,0x1f,0xa6,0xef,0xff,0x9f,0x2f,0xef,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0x97,0xbf,0x0b,0xee,0x36,0xff,0xcb,0x87,0xf0,0xff,0xff,0xf7,0xff,0xef,0xff,0xff,
		0xf7,0xef,0xff,0xff,0xf3,0xef,0xff,0xff,0x07,0xe4,0xff,0xff,0xf3,0xd5,0xfe,0xff,
		0xf5,0xc0,0xfe,0xff,0x77,0xdb,0xfe,0xff,0x37,0x1d,0xfe,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
		0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	] ) );

	im[ 0 ] = TUGames.TURawImage.CreateFromTUPicture( im[ 0 ] );
	im[ 1 ] = TUGames.TURawImage.CreateFromTUPicture( im[ 1 ] );

	start( im );
}
